{i found this code - i believe - in a pc techniques
magazine article quite a while ago (probably just after delphi 1.0 was released
in 1995.  recently i needed a component like this and - amazingly enough - i was
able to find it in my code archives (what a break).  anyway - i made some changes to
the component so that it now simulates "blinking" behaviour.

i offer all of this as a way of giving credit where credit is due.  all though
i cannot find the original author of the code nor can i find the magazine and
the article that it came from - my belief is that the original author of this
code is ray konopka (now legendary in the delphi community).  i only take credit
for the mods that allow it to "blink".  the only stipulation that i place on the
usage of this code is that you DO NOT change the comments at the top of this file.

this code is offered as a leaning tool (as is) and i take no responsibility
beyond that.  please use it at your own risk and if it helps you out -
remember to GIVE SOMETHING BACK to the delphi programming community in
whatever way you can.

if you do have any questions or suggestions for enhancements - i can be reached
at the following contacts

mark meyer
work - markmeyer@cybertek.com
home - geeky2@gte.net
compuserve - 72260,2524


}


unit Traflite;

interface {=== TrafLite Unit ===}

  uses
    Controls, Classes, Forms, DsgnIntf, StdCtrls, Graphics, extctrls;

  const                      { Special Colors for Traffic Light }
    clDullRed       = TColor( $000040 );
    clDullYellow    = TColor( $408080 );
    clDullGreen     = TColor( $004000 );
    clTrafficYellow = TColor( $00C0C0 );

  type
    TActiveLight = ( alNone, alRed, alYellow, alGreen, alall );
    TLightArray = array[ TActiveLight ] of TColor;
		tonblinkevent = procedure (sender : tobject) of object;

  const       { Light color must change to reflect active light }
    RedLightColor    : TLightArray = ( clDullRed,    clRed,        clDullRed,   clDullRed,    clRed );
    YellowLightColor : TLightArray = ( clDullYellow, clDullYellow, clYellow,    clDullYellow, clYellow );
    GreenLightColor  : TLightArray = ( clDullGreen,  clDullGreen,  clDullGreen, clLime,       clLime );

  type

    TTrafficLight = class( TGraphicControl )
    private
      FActiveLight : TActiveLight;
      FCaseColor   : TColor;
      fblinking : boolean;
      fblinkstate : boolean;
    	fblinktimer : ttimer;
      fblinktimerenabled : boolean;
      fblinktimerinterval : cardinal;
      fonblink : tonblinkevent;
			procedure fblinktimertimer(sender:tobject);

    protected
      procedure SetActiveLight( Value : TActiveLight );
      procedure SetCaseColor( Value : TColor );
      procedure setblinking(value:boolean);
      procedure setblinkstate(value:boolean);
      procedure setfblinktimerinterval(value:cardinal);
      procedure Paint; override;
			procedure doonblink;
    public
			destructor destroy; override;
      constructor Create(AOwner: TComponent); override;

    published
      property ActiveLight : TActiveLight read FActiveLight write SetActiveLight;
			property blinktimerinterval : cardinal read fblinktimerinterval write setfblinktimerinterval;
			property blinking : boolean read fblinking write setblinking;
      property blinkstate : boolean read fblinkstate write setblinkstate;
      property CaseColor : TColor read FCaseColor write SetCaseColor;
      property OnClick;            { Make OnClick event visible }
      property onblink : tonblinkevent read fonblink write fonblink;

    end;

  procedure Register;

implementation {=== TrafLite Unit ===}

  uses
    Messages, WinTypes, WinProcs;


  {===========================}
  {== TTrafficLight Methods ==}
  {===========================}



	procedure ttrafficlight.fblinktimertimer(sender:tobject);
	begin
		blinkstate := not(blinkstate);
	end;

  procedure ttrafficlight.doonblink;
  begin
  	if (assigned(fonblink)) then begin
    	fonblink(self);
		end;{if}
  end;


  constructor TTrafficLight.Create( AOwner : TComponent );
  begin
    inherited Create( AOwner );

    fblinktimer := ttimer.create(self);
    fblinktimer.enabled := false;
    fblinktimerenabled := false;
    fblinktimer.interval := 3000;
    fblinktimerinterval := 3000;

    fblinktimer.ontimer := fblinktimertimer;

    blinking := false;
		blinkstate :=false;

    FActiveLight := alall;           { Set Default Active Light }
    FCaseColor := clTrafficYellow;     { Set Default Case Color }
    Width := 48;                            { Set Default Width }
    Height := 60;                          { Set Default Height }
  end; {= TTrafficLight.Create =}



  procedure ttrafficlight.setblinking( value : boolean );
  begin
    if (value <> fblinking) then begin
      fblinking := Value;
    end;{if}
		if not(value) then begin
			fblinktimer.enabled := false;
		end{if}
    else begin
			fblinktimer.enabled := true;
    end;{else}
  end;


  procedure ttrafficlight.setfblinktimerinterval(value : cardinal);
  begin
    if (value <> fblinktimerinterval) then begin
      fblinktimerinterval := value;
      fblinktimer.interval := value;
    end;
  end;


  procedure ttrafficlight.setblinkstate(value : boolean);
  begin
    if (value <> fblinkstate) then begin
      fblinkstate := value;
      refresh;
    end;
  end;



  procedure TTrafficLight.SetActiveLight( Value : TActiveLight );
  begin
    if Value <> FActiveLight then
    begin
      FActiveLight := Value;
      Repaint;                  { Repaint with new Active Light }
    end;
  end; {= TTrafficLight.SetActiveLight =}


  procedure TTrafficLight.SetCaseColor( Value : TColor );
  begin
    if Value <> FCaseColor then
    begin
      FCaseColor := Value;
      Repaint;
    end;
  end; {= TTrafficLight.SetCaseColor =}


	destructor ttrafficlight.destroy;
	begin
  	fblinktimer.free;
  	inherited destroy;
	end;



  procedure TTrafficLight.Paint;
  var
    RegionX, CenterX, RegionY, DeltaY, Radius : Integer;

    {= DrawCovers - Draws the black triangular covers on sides =}
    procedure DrawCovers( X, CY, R : Integer );
    begin
      Canvas.Polygon( [ Point( X, CY - R ),
                        Point( 0, CY - R ),
                        Point( X, CY ) ] );
      Canvas.Polygon( [ Point( 3 * X, CY - R ),
                        Point( 4 * X, CY - R ),
                        Point( 3 * X, CY ) ] );
    end; {= DrawCovers =}

    {= DrawLight - Draws Red, Yellow, or Green light on front =}
    procedure DrawLight( CX, CY, R : Integer );
    begin
      { Draw the actual light }
      Canvas.Ellipse( CX - R, CY - R, CX + R, CY + R );
      { Draw a straight-on view of cover over the light }
      Canvas.Arc( CX - R, CY - R + 1, CX + R, CY + R,
                  CX + R, CY, CX - R, CY );
      Canvas.Arc( CX - R, CY - R + 2, CX + R, CY + R,
                  CX + R, CY, CX - R, CY );
    end; {= DrawLight =}

  begin {= TTrafficLight.Paint =}
    RegionX := Round( Width / 4 );            { Position Values }
    CenterX := Round( Width / 2 );
    RegionY := Round( Height / 3 );
    DeltaY  := Round( Height / 6 );
    Radius  := Round( Height / 8 );

    with Canvas do
    begin
      Brush.Color := FCaseColor; { Draw case using FCaseColor }
      RoundRect( RegionX, 0, 3 * RegionX, Height, 6, 6 );

      { Draw all three sets of light covers }
      Brush.Color := clBlack;      { Covers are painted black }
      DrawCovers( RegionX, DeltaY, Radius );
      DrawCovers( RegionX, RegionY + DeltaY, Radius );
      DrawCovers( RegionX, 2 * RegionY + DeltaY, Radius );

      { Drawing the Lights:
        The appropriate light color is determined by the
        Active Light and the corresponding Color Array }

      { Red Light }
			if (factivelight = alred) then begin
	      if (blinkstate and blinking) then begin
		      Brush.Color := RedLightColor[ alnone ];
				end{if}
    	  else begin
		      Brush.Color := RedLightColor[ FActiveLight ];
	      end;{else}
    	  DrawLight( CenterX, DeltaY, Radius );
      end{if}
      else begin
				Brush.Color := RedLightColor[ FActiveLight ];
				DrawLight( CenterX, DeltaY, Radius );
      end;{else}

      { Yellow Light }
      if (factivelight = alyellow) then begin
	      if (blinkstate and blinking) then begin
		      Brush.Color := YellowLightColor[alnone];
    	  end{if}
      	else begin
  		    Brush.Color := YellowLightColor[ FActiveLight ];
	      end;{else}
				DrawLight( CenterX, RegionY + DeltaY, Radius );
			end{if}
      else begin
				Brush.Color := YellowLightColor[ FActiveLight ];
				DrawLight( CenterX, RegionY + DeltaY, Radius );
      end;{else}

      { Green Light }
      if (factivelight = algreen) then begin
				if (blinkstate and blinking) then begin
		      Brush.Color := GreenLightColor[ alnone ];
    	  end{if}
      	else begin
	      	Brush.Color := GreenLightColor[ FActiveLight ];
				end;{else}
		    DrawLight( CenterX, 2 * RegionY + DeltaY, Radius );
			end{if}
      else begin
				Brush.Color := GreenLightColor[ FActiveLight ];
				DrawLight( CenterX, 2 * RegionY + DeltaY, Radius );
      end;{else}

      { all lights }
      if (factivelight = alall) then begin
				if (blinkstate and blinking) then begin
		      Brush.Color := RedLightColor[ alnone ];
	    	  DrawLight( CenterX, DeltaY, Radius );
		      Brush.Color := YellowLightColor[alnone];
					DrawLight( CenterX, RegionY + DeltaY, Radius );
		      Brush.Color := GreenLightColor[ alnone ];
			    DrawLight( CenterX, 2 * RegionY + DeltaY, Radius );
    	  end{if}
      	else begin
		      Brush.Color := RedLightColor[ factivelight ];
	    	  DrawLight( CenterX, DeltaY, Radius );
		      Brush.Color := YellowLightColor[factivelight];
					DrawLight( CenterX, RegionY + DeltaY, Radius );
	      	Brush.Color := GreenLightColor[ factivelight ];
					DrawLight( CenterX, 2 * RegionY + DeltaY, Radius );
				end;{else}
			end;{if}
    end; { with }
  end; {= TTrafficLight.Paint =}


  {= Register the TrafficLight component with Delphi and place =}
  {= under Blazing Pascal tab in component palette.            =}
  procedure Register;
  begin
    RegisterComponents( 'Blazing Pascal', [ TTrafficLight ] );
  end;

end. {=== TrafLite Unit ===}

